<template>
  <GenericLayout>
    <template #header>
      <Header
        back-button
        :title="pageTitle"
        :badge-content="pageSubTitle"
      />
    </template>
    <template #page-content>
      <div>
        <template v-if="isDesktopPlatform">
          <div
            class="page-title"
            v-if="pageTitle"
          >
            {{ pageTitle }}
          </div>
          <div
            class="page-subtitle"
            v-if="pageSubTitle"
          >
            {{ pageSubTitle }}
          </div>
        </template>

        <q-card :square="!isDesktopPlatform">
          <q-card-section>
            <SearchAndFilters
              :holding-campaign-id="holdingCampaignId"
              :search-value="searchValue"
              @new-search-value="updateSearchValue"
              :selected-site-id="selectedSiteId"
              @new-selected-site-id="updateSelectedSite"
              :dense="true"
            />
          </q-card-section>

          <div
            v-if="loading"
            class="column flex-center"
          >
            <q-spinner-dots
              color="primary"
              size="2em"
            />
          </div>

          <template v-else-if="plots">
            <q-card-section class="q-pt-sm">
              <div
                v-if="!$apollo.queries.plotsNumber.loading"
                class="text-grey"
              >
                <translate
                  v-if="numberFilteredPlots > 0"
                  :translate-params="{count: numberFilteredPlots}"
                >
                  %{ count } plot(s) found
                </translate>
                <translate v-else>
                  No plot found
                </translate>
              </div>
            </q-card-section>

            <div>
              <q-infinite-scroll
                @load="loadMore"
                :offset="infiniteScrollOffset"
                ref="infiniteScrollComponent"
                :scroll-target="'body'"
              >
                <PlotsPreviewList
                  :plots="plots"
                  :no-plot-section="false"
                />
                <template #loading>
                  <div class="row justify-center q-my-md">
                    <q-spinner-dots
                      color="primary"
                      size="2em"
                    />
                  </div>
                </template>
              </q-infinite-scroll>
            </div>
          </template>
        </q-card>
      </div>
    </template>
    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'
import SearchAndFilters from 'src/pages/holding-campaign/plot/components/SearchAndFilters'
import PlotsPreviewList from 'src/pages/holding-campaign/components/PlotsPreviewList'
import queryPlotsBySiteAndSearch from 'src/pages/holding-campaign/plot/graphql/queryPlotsBySiteAndSearch'
import countPlotsBySiteAndSearch from 'src/pages/holding-campaign/plot/graphql/countPlotsBySiteAndSearch'

export default {
  name: 'PlotsPage',
  mixins: [
    PlatformMixin
  ],
  components: {
    GenericLayout,
    Header,
    Footer,
    SearchAndFilters,
    PlotsPreviewList
  },
  data () {
    return {
      searchValue: '',
      selectedSiteId: null,
      lastPlotId: 0
    }
  },
  computed: {
    numberToLoadPerRequest () {
      return this.isDesktopPlatform ? 25 : 15
    },
    infiniteScrollOffset () {
      return 250
    },
    pageTitle () {
      return this.$store.state.fastplatform.holdingCampaign.holding.name
    },
    pageSubTitle () {
      return this.$store.state.fastplatform.holdingCampaign.campaign.name
    },
    holdingCampaignId () {
      return this.$store.state.fastplatform.holdingCampaign.id
    },
    numberFilteredPlots () {
      if (this.plotsNumber && this.plotsNumber.plot_aggregate) {
        return this.plotsNumber.plot_aggregate.aggregate.count
      } else {
        return null
      }
    },
    searchValueForQuery () {
      return `%${this.searchValue}%`
    },
    loading () {
      return !this.plots && this.$apollo.queries.plots.loading
    }
  },
  apollo: {
    plots: {
      query: queryPlotsBySiteAndSearch,
      notifyOnNetworkStatusChange: true,
      variables () {
        return this.getQueryPlotsVariables(this.lastPlotId)
      }
    },
    plotsNumber: {
      query: countPlotsBySiteAndSearch,
      notifyOnNetworkStatusChange: true,
      variables () {
        return this.getQueryPlotsVariables(null, true)
      },
      update: data => data
    }
  },
  methods: {
    doBeforeUpdate () {
      // reset the infinite scroll behavior
      this.resetInfinitScrollBehavior()
    },
    loadMore (index, done) {
      if (this.plots?.length) {
        const lastPlotId = this.plots[this.plots.length - 1].id
        this.$apollo.queries.plots.fetchMore({
          variables: this.getQueryPlotsVariables(lastPlotId),
          updateQuery: (previousResult, { fetchMoreResult }) => {
            return {
              plots: [...previousResult.plots, ...fetchMoreResult.plots]
            }
          }
        }).then(() => {
          if (this.plots && this.numberFilteredPlots) {
            if (this.plots.length === this.numberFilteredPlots) {
              // no more data to load stop infinite scroll
              done(true)
            } else {
              // there's still more content to load
              done()
            }
          } else {
            // secure case to avoid the infinite scroll component to be stucked in a loading state
            done()
          }
        }).catch(e => {
          console.error(e)
          // prevent the infinite scroll component to load more data since there was an error
          done(true)
        })
      } else {
        // The initial data was still not loaded
        done()
      }
    },
    resetInfinitScrollBehavior () {
      // reset the infinite scroll component behavior (reset the index, and resume if stopped) in case the query change
      // (new filter or search value)
      this.$refs.infiniteScrollComponent.reset()
      this.$refs.infiniteScrollComponent.resume()
    },
    updateSearchValue (newValue) {
      this.doBeforeUpdate()
      this.searchValue = newValue
    },
    updateSelectedSite (newValue) {
      this.doBeforeUpdate()
      this.selectedSiteId = newValue
    },
    getQueryPlotsVariables (lastPlotId, isCount = false) {
      const whereClause = {
        site: { holding_campaign_id: { _eq: this.holdingCampaignId } }
      }
      if (!isCount) {
        whereClause.id = { _gt: lastPlotId }
      }
      if (this.searchValue) {
        whereClause._or = [{ authority_id: { _ilike: this.searchValueForQuery } }, { name: { _ilike: this.searchValueForQuery } }]
      }
      if (this.selectedSiteId) {
        whereClause.site_id = { _eq: this.selectedSiteId }
      }
      const variables = {
        where: whereClause
      }
      if (!isCount) {
        variables.limit = this.numberToLoadPerRequest
      }
      return variables
    }
  },
  mounted () {
    // Get the potential selected site from the query paramters
    if (this.$route.query.siteId) {
      this.selectedSiteId = Number(this.$route.query.siteId)
    }
  }
}
</script>
